/*******************************************************************************/
/*                                                                             */
/*   common.c :  uÓVwvLڂ̕@ɂVvZ̊{vZ֐            */
/*      Ver. 1.3    2016/01/28         By    takesako@mrj.biglobe.ne.jp        */
/*                                         (c)1999-2016 Shinobu Takesako       */
/*******************************************************************************/
//   1999/06/29 avZǉɔC                                         
//   1999/07/02 PʒuvZǉɔǉ                                     
//              PrecessioñoOC                             			   
//   2016/01/28 Calendar()}CiXjudayɂΉ                              
//              XΊp̌vZ2000NɑΉ邽Obl0_2000(jd)ǉ  
//              RaToLam()Az_El()Ɏgpobl2000NɕύX              
//              x番b\̕b؂̂           
/*******************************************************************************/

#include <stdio.h>
#include <math.h>

#include "astro.h"

/*******************************************************************************/
/*                      EX̌vZ                                       */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

double JD(double year,double month,double day,double hour,int LST,double longitude)
{
	double s,juday,a,flag;

	flag =1;
	if (longitude <0){ 
		longitude = -longitude;
		flag=-1;
		}

	if ( month < 3 ){
		year = year -1;
		month = month +12;
		};
	s = floor( 365.25 * year) + floor( 30.59 * (month-2.0));
	if (LST==1)
	{juday = s + day + hour/24.0 -  flag*floor(longitude /15.0+0.5)/24.0	+ 1721086.5;}
		else
		{juday = s + day + hour/24.0 -  flag*longitude /15.0/24.0	+ 1721086.5;}


	if ( juday > 2299150 ) {
		a = floor ( year / 400 ) - floor( year / 100)+2;
		juday = juday + a;
		};

	return(juday);

}
/*******************************************************************************/
/*                      ̌vZ                                             */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/
// jd}CiX̏ꍇɂΉ悤ɏC@(2016/01/28)

void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = (double)(int)(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = (double)(int) ((B-122.1)/365.25);
	D = (double)(int) (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - (double)(int)(30.60001*E) + F;
	*day = (double)(int)(Day0);
	*hour= F*24.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;


}

/*******************************************************************************/
/*                      吔̂܂ߌvZ                                       */
/*******************************************************************************/

double Compact (double y, double x)
{
	y = x * ( y / x - floor (y / x));
	if((int)x==360 && y <0) y=y+360.0;
	return(y);
}


/*******************************************************************************/
/*                      \̒l̋ߎij                                   */
/*******************************************************************************/

double Table_Value(double a, double b, double c, double d, double Diff_ba, double Diff_ca)
{

	double ac, bd, acbd;
	
/*	
               Diff_ca
           a      ac       c
  Diff_ba        abcd 
           b      bd       d
*/

	ac = a + (c-a)*Diff_ca/10.0;
	bd = b + (d-b)*Diff_ca/10.0;
	acbd = ac +(bd-ac)*Diff_ba/10.0;

 return acbd;
}


/*******************************************************************************/
/*                      kršvZ                                           */
/*******************************************************************************/

double LST( double jd, double longitude)
{
	double lst,GST0 = 18.6461, JD0=2415020.0, R,b ;

	R = 366.2422/365.2422;
	b = jd - JD0;
	lst = GST0 + 24 * b * R + 3.24E-14 * b * b +longitude/15.0;
	lst = Compact(lst,24);
	if (lst<0.0){
		lst = lst +24;
		};
	return lst;
}

/*******************************************************************************/
/*                      QOOON̐ǏvZ                           */
// 2016/01/28 ǉ																*/
/*******************************************************************************/

double T_2000 (double jd)
{
	double JD0=2451545.0 , t ;
	t=(jd-JD0)/(100.0*365.25);
	return t ;
}

/*******************************************************************************/
/*                      PXOON̐ǏvZ                           */
/*******************************************************************************/

double C_1900 (double jd)
{
	double JD0=2415021.0 , c ;
	c=(jd-JD0)/(100.0*365.25);
	return c ;
}


/*******************************************************************************/
/*                      PWOON̐ǏvZ                           */
/*******************************************************************************/

double J_1800 (double jd)
{
	double j;
	j = ( jd - 2378496.0 ) / 36525.0;
	return (j);
}


/*******************************************************************************/
/*                      XΊp̌vZ (1900N)                                       */
/*******************************************************************************/
double Obl(double jd)
{
	double c,obl;
	
	c=C_1900(jd);
	obl = 23.4523 - 0.013*c -0.00000016388*c*c ; 

	return obl;
}
/*******************************************************************************/
/*                      XΊp̌vZ(2000N)                                        */
// 2016/01/28 ǉ																*/
/*******************************************************************************/


double Obl0_2000(double jd) // without Nutation
{
	double t,obl;

	t=T_2000(jd);
	obl = 23.439279444 - 0.01301021361*t - 5.0861e-8*t*t + 5.565e-7*t*t*t-1.6e-10*t*t*t*t-1.2056e-11*t*t*t*t*t; 

	return obl;
}

/*******************************************************************************/
/*                      o܂ԌoԈ܂ւ̕ϊ                           */
/*******************************************************************************/

void LamToRa(double jd,double Lam,double Bet,double *RA,double *DEC)
{

	double obl;
	
	obl = Obl0_2000(jd); // 2016/01/28 2000NɕύX
	
	*RA  = atan2((cos(obl*pai)*cos(Bet*pai)*sin(Lam*pai)-sin(obl*pai)*sin(Bet*pai)),cos(Bet*pai)*cos(Lam*pai))/pai;
	if (*RA <0) *RA = *RA +360.0;
	*DEC = asin (cos(obl*pai)*sin(Bet*pai)+sin(obl*pai)*cos(Bet*pai)*sin(Lam*pai))/pai;

}

/*******************************************************************************/
/*                      ԌoԈ܂物o܂ւ̕ϊ                           */
/*******************************************************************************/

void RaToLam(double jd,double RA,double DEC,double *Lam,double *Bet)
{

	double obl;
	
	obl = Obl0_2000(jd);// 2016/01/28 2000NɕύX
	
	*Lam  = atan2((sin(obl*pai)*sin(DEC*pai)+cos(obl*pai)*cos(DEC*pai)*sin(RA*pai)),cos(DEC*pai)*cos(RA*pai))/pai;
	if (*Lam <0) *Lam = *Lam +360.0;
	*Bet = asin (cos(obl*pai)*sin(DEC*pai)-sin(obl*pai)*cos(DEC*pai)*sin(RA*pai))/pai;

}

/*******************************************************************************/
/*                      ԌoԈ܂ʍx̌vZ                             */
/*          AǍvŹuÓVwvLڂ̌vZł͂܂B           */
/*******************************************************************************/
 
void Az_El(double jd,double Ra, double Dec, double latitude,double longitude,  double *Az, double *El )
{
	double lst,lat,Ha,a,b;

    lst = LST(jd,longitude)*15.0;
	lat = latitude;
	Ha  = lst - Ra;

	a   = sin (Ha * pai);
	b   = cos (Ha * pai) * sin (lat * pai) - tan(Dec*pai)*cos(lat*pai);
	*Az = atan2 (a,b)/pai;
	*El =asin(sin (lat *pai) * sin ( Dec * pai) + cos (lat *pai)* cos ( Dec *pai)*cos(Ha*pai))/pai;

}


/*******************************************************************************/
/*                      tϐN̕                               */
/*******************************************************************************/

void DateToYMD(double Date,double *year,double *month,double *day)

{
	double flag,Year,Month;
	
	flag=0;
	
	if (Date<0) {
		Date=-Date;
	    flag = 1;
	    };
	Year  = floor(Date);
	Month = floor((Date-Year)*100);
	*day  = (Date*10000-Year*10000-Month*100);
	*year = Year;
	*month= Month;
	if(flag==1) *year = -*year;

}

/*******************************************************************************/
/*                      ԕb\玞Ԃւ̕ϊ                           */
/*******************************************************************************/
double HMSToHour(double HMS)

{
	int flag=0;
	double H,Hour,Min,Sec;
	
	if (HMS<0){
		flag=1;
		HMS=-HMS;
		};
	Hour  = floor(HMS);
	Min   = floor((HMS - Hour)*100);
	Sec   = (HMS*10000-Hour*10000-Min*100);
	H     = Hour + Min/60.0 +  Sec/3600.0;
    if(flag==1)H=-H;
	return H;
}

/*******************************************************************************/
/*                      ԕb\pxւ̕ϊ  ( 1999/07/01 ǉ )      */
/*******************************************************************************/
double HMSToDeg(double HMS)

{
	double H,Deg;
	
	H=HMSToHour( HMS);
	
	Deg = H*15.0;
	return Deg;
}

/*******************************************************************************/
/*                      xb\xւ̕ϊ                               */
/*******************************************************************************/

double DMSToDeg(double DMS)

{
	int flag=0;
	double D,Deg,Min,Sec;
	
	
	if (DMS<0){
		flag=1;
		DMS=-DMS;
		};
	Deg   = floor(DMS);
	Min   = floor((DMS - Deg)*100);
	if(Min>99.0){Min=Min-100;Deg=Deg+1;}
	Sec   = DMS*10000-Deg*10000-Min*100;
	if(Sec>99.0){Sec=Sec-100;Min=Min+1;}
	D     = Deg +  Min/60.0 +  Sec/3600.0;
	if(flag==1)D=-D;
    return D;

}

/*******************************************************************************/
/*                      x\玞b\ւ̕ϊ                           */
/*******************************************************************************/

double DegToHMS(double D)

{
	int    flag=0;
	double Hour,Min, Sec,H;
	
	if(D<0) {
		D=-D;
		flag=1;
		};

	D     = D/15.0;
	Hour  = floor(D);
	Min   = floor((D - Hour)*60);
	Sec   = (double)(int)D*3600-Hour*3600-Min*60;//؎̂(2016/01/28C)
	H     = Hour +  Min/100.0 +  Sec/10000.0;
	if(flag==1)H=-H;

    return H;
}

/*******************************************************************************/
/*                      x\xb\ւ̕ϊ                           */
/*******************************************************************************/

double DegToDMS(double D)

{

	int    flag=0;
	double Deg,Min,Sec,H;
	
	if(D<0) {
		D=-D;
		flag=1;
		};
	Deg   = floor(D);
	Min   = floor((D - Deg)*60.0);
	Sec   = (double)(int)(D*3600-Deg*3600-Min*60);//؎̂(2016/01/28C)
	H     = Deg +  Min/100.0 + Sec/10000.0;
	if(flag==1)H=-H;
    return H;
}

/*******************************************************************************/
/*                      _ʂł̎ľܓ                               */
/*******************************************************************************/
double Digit2( double x)
{
	int flag=0;

	if(x<0){
		x=-x;
		flag=1;
	}
	x=(double)((int)(x*100.0+0.5));
	x=x/100.0;
	if(flag==1)x=-x;
	return x;

}

/*******************************************************************************/
/*                      _Oʂł̎ľܓ                               */
/*******************************************************************************/

double Digit3( double x)
{
	int flag=0;

	if(x<0){
		x=-x;
		flag=1;
	}
	x=(double)((int)(x*1000.0+0.5));
	x=x/1000.0;
	if(flag==1)x=-x;
	return x;

}

/*******************************************************************************/
/*                     ΍̌vZ                                              */
/*              (Astronomical algorithmsɂ)                                */
/*******************************************************************************/

void Precession (double jd, double Year0, double RA0,double DEC0,double V1,double V2,double *RA,double *DEC)
{
	double jd0,t,T, Zeta,Zeta1,Zeta2,Zeta3,Theta,Theta1,Theta2,Theta3,Zed,Zed1,Zed2,Zed3;
	double CosTheta,SinTheta ,CosDec0,SinDec0,CosRaZeta ,SinRaZeta;

	jd0=JD( Year0,1,1,12,0,0);/*1999/07/02*/

	T=(jd0-2451545.0)/36525.0;/*1999/07/02*/
	t=(jd-jd0)/36525.0;

	Zeta1  = 2306.2181 + 1.39656*T - 0.000139*T*T;
	Zeta2  = 0.30188 - 0.000344*T;
	Zeta3  = 0.017998;
	Theta1 = 2004.3109 - 0.85330*T - 0.000217*T*T;
	Theta2 = - ( 0.42665 + 0.000217*T);
	Theta3 = - 0.041833;
	Zed1   = 2306.2181 + 1.39656*T - 0.000139*T*T;
	Zed2   = 1.09468 + 0.000066*T;
	Zed3   = 0.018203;

/* for B1900 system uÓVw̒萔v@*/
/*
	jd0=JD( Year0,1,0,19.31264,0,0);
	t=(jd-jd0)/36525.0;

	Zeta1  = 2304.250;
	Zeta2  =    0.302;
	Zeta3  =    0.018;
	Theta1 = 2004.68 ;
	Theta2 =   -0.426;
	Theta3 =   -0.042;
	Zed1   = 2304.250;
	Zed2   =    1.093;
	Zed3   =    0.018;
*/

	Zeta  = (  Zeta1*t +  Zeta2*t*t + Zeta3*t*t*t )/3600.0;
	Zed   = (   Zed1*t +   Zed2*t*t +  Zed3*t*t*t )/3600.0;
	Theta = ( Theta1*t + Theta2*t*t +Theta3*t*t*t )/3600.0;

/*printf("Zeta=%10.3f Zed =%10.3f Theta=%10.3f \n",Zeta,Zed,Theta);*/

	Zeta = Zeta*pai;
	Zed  = Zed*pai;
	Theta= Theta*pai;
	RA0  = (RA0 + V1*t*100/3600.0/cos(DEC0*pai))*pai;
	DEC0 = (DEC0+ V2*t*100/3600.0)*pai;

	CosTheta  = cos (Theta);
	SinTheta  = sin (Theta);
	CosDec0   = cos (DEC0);
	SinDec0   = sin (DEC0);
	CosRaZeta = cos(RA0+Zeta);
	SinRaZeta = sin(RA0+Zeta);

	*DEC   = asin (CosTheta*SinDec0 + SinTheta*CosDec0*CosRaZeta)/pai;
	*RA =atan2(CosDec0*SinRaZeta ,CosTheta*CosDec0*CosRaZeta-SinTheta*SinDec0)/pai;
	*RA =*RA + Zed/pai;
	if (*RA<0) *RA += 360.0;

}
